import { select,csv,mean } from 'd3';

// let data = csv("data.csv",d=>{
// 	d.measure = +d.measure;
//   return d.measure;
// })
function calculateMR(arr){
  let result = [0],i,mr = arr[0];
  for (i = 1; i <arr.length; i++) {
     result.push(Math.abs(arr[i] - mr));
    	mr = arr[i]
	}
  return result;
}
const pointsAboveSigma = (minElem,avg,ravg,alpha) =>{
  if ((minElem - avg) > ravg * alpha)
    return true;
  else
    return false;
  // alpha 1.98
  // alpha 1.08
}
const sevenPointAboveAverage = (minElem,avg) =>{
  if(minElem > avg)
    return true;
  else
    return false;
}
const calculateMinimum = (i,gap,top12Measure,lastElem) =>{
  let max = i+1;
  let min = max-gap<0?0:max-gap;
  let sliceArr = top12Measure.slice(min,max)
  let sliceLen = sliceArr.length;
  
  
  //   if(typeof lastElem!== "undefined"){
  //       let len = lastElem.length;
  // 			console.log(lastElem.slice(len-(gap-sliceLen),len),top12Measure)
  // }
  if(sliceLen < gap && typeof lastElem!== "undefined"){
    let len = lastElem.length;
  	// console.log(lastElem.slice(len-(gap-sliceLen),len),sliceArr)
    
  	return Math.min(...sliceArr,lastElem.slice(len-(gap-sliceLen),len))
  }
  // console.log(sliceArr)
  
  return Math.min(...sliceArr)
}
function calculateBreakPoint(top12Measure,avg,ravg,lastElem){
  // console.log(top12Measure.length,avg,ravg)
  let i;
  for(i = 0; i<12;i++){
    let minElem1 = calculateMinimum(i,2,top12Measure,lastElem);
    let result1 = pointsAboveSigma(minElem1,avg,ravg,1.98) //two points above 2 sigma
    let minElem2 = calculateMinimum(i,3,top12Measure,lastElem)    
    let result2 = pointsAboveSigma(minElem2,avg,ravg,1.08) // three points above 1 sigma
    let minElem3 = calculateMinimum(i,7,top12Measure,lastElem)
    let result3 = sevenPointAboveAverage(minElem3,avg)
    if(result1 || result2 || result3)
      return i
    
  }
	return i
}
let lowerBound = [];
let upperBound = [];
let data= [24, 25, 26, 26, 25, 26, 27, 28, 29, 30, 31, 30, 35, 35, 36, 35, 34, 33, 34, 36, 37, 38, 40, 37, 41, 40, 42, 41, 41, 45, 46, 43, 45, 47, 49, 47, 45, 47, 52];
// let data = [0,0,0.1,0.1,8.2,1.8,0,0,0.2,0.3,10,0.6,2.2,0,0.2,0.2,8,3.5,0.4,0,0,0,10.4,0.8,0,0,0,0.2,12,4.5,2,0.5,0.4,0.3,10,0.4,0.3,0.3,0.3]

let mrall = calculateMR(data);

let breakpoint = 0;
let flag = false;
let avg,ravg;
let lastElem ;
for(let start = 0;start < data.length;){
  // console.log(start)
  let top12Measure = data.slice(start,start+12);
	let mr = mrall.slice(start,start+12);
  if(!flag){
  	avg = mean(top12Measure)
		ravg = mean(mr); //average 12 not 11 for first case
  }
	
  // console.log(avg,ravg)
  
	breakpoint = calculateBreakPoint(top12Measure,avg,ravg,lastElem)
  // console.log(breakpoint)
  if(breakpoint === 12)
    flag = true;
  else
    flag = false;
  for(let x = start;x < start + breakpoint && x < data.length;x++){
    lowerBound.push(avg - (ravg*2.66))
    upperBound.push(avg + (ravg*2.66))
  }
	start += breakpoint;
  // lastElem = top12Measure[top12Measure.length -1]
  lastElem = top12Measure
}
console.log(lowerBound)
console.log(upperBound)
